#
# This is the SPEC file for creating binary RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <https://www.gnu.org/licenses/>.
#
#

Name:		qubes-core-qrexec
Version:	4.2.3
Release:	1%{dist}
Summary:	The Qubes qrexec files (common files)

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

BuildRequires:	gcc
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:	python%{python3_pkgversion}-dbus
# for building documentation
BuildRequires:	python%{python3_pkgversion}-sphinx
BuildRequires:	python%{python3_pkgversion}-recommonmark
BuildRequires:	qubes-libvchan-devel
BuildRequires:  python%{python3_pkgversion}-rpm-macros

Requires:   python%{python3_pkgversion}
Requires:   python%{python3_pkgversion}-gbulb
Conflicts:  qubes-utils-libs < 4.1.0
Conflicts:  qubes-core-agent-qrexec < 4.1.0
Conflicts:  qubes-core-dom0 < 4.1.10
Conflicts:  qubes-core-dom0-linux < 4.1.5
Conflicts:  qubes-gui-agent < 4.1.6
Conflicts:  qubes-gpg-split < 2.0.45
Conflicts:  qubes-gui-daemon < 4.1.4
Conflicts:  qubes-input-proxy < 1.0.17
Conflicts:  qubes-pdf-converter < 2.1.7
Conflicts:  qubes-usb-proxy < 1.0.28

Source0: qubes-core-qrexec-%{version}.tar.gz

%description
The Qubes qrexec files for installation on both dom0 and qube.

%package libs
Summary:    Libraries for qubes-qrexec
Conflicts:  qubes-utils-libs < 4.1.0

%description libs
Libraries for qubes-qrexec

%package devel
Summary:    Development headers for qubes-qrexec
Requires:   %{name}-libs

%description devel
Development header and files for qubes-qrexec

%prep
%setup -qn qubes-core-qrexec-%{version}

%build
%{?set_build_flags}
make all-base PYTHON=%{__python3}
make -C doc PYTHON=python3 SPHINXBUILD=sphinx-build-3 man

%install
make install-base \
    INCLUDEDIR=%{_includedir} \
    LIBDIR=%{_libdir} \
    SYSCONFDIR=%{_sysconfdir} \
    UNITDIR=%{_unitdir} \
    PYTHON_SITEPATH=%{python3_sitelib} \
    PYTHON=%{__python3} \
    DESTDIR=$RPM_BUILD_ROOT

make -C doc \
    DESTDIR=$RPM_BUILD_ROOT \
    SPHINXBUILD=sphinx-build-3 \
    install

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)

%{_bindir}/qrexec-policy-exec
%{_bindir}/qrexec-policy-agent
%{_bindir}/qrexec-policy-graph
%{_bindir}/qrexec-policy-restore
%{_bindir}/qrexec-policy-daemon
%{_bindir}/qubes-policy
%{_bindir}/qubes-policy-admin
%{_bindir}/qrexec-policy

/usr/lib/qubes/qubes-rpc-multiplexer
/usr/lib/qubes/qrexec-policy-agent-autostart

%{_sysconfdir}/qubes-rpc/policy.Ask
%{_sysconfdir}/qubes-rpc/policy.Notify

%{_sysconfdir}/xdg/autostart/qrexec-policy-agent.desktop

%dir %{python3_sitelib}/qrexec-*.egg-info
%{python3_sitelib}/qrexec-*.egg-info/*

%dir %{python3_sitelib}/qrexec
%dir %{python3_sitelib}/qrexec/__pycache__
%{python3_sitelib}/qrexec/__pycache__/*
%{python3_sitelib}/qrexec/__init__.py
%{python3_sitelib}/qrexec/client.py
%{python3_sitelib}/qrexec/exc.py
%{python3_sitelib}/qrexec/utils.py
%{python3_sitelib}/qrexec/server.py

%dir %{python3_sitelib}/qrexec/policy
%dir %{python3_sitelib}/qrexec/policy/__pycache__
%{python3_sitelib}/qrexec/policy/__pycache__/*
%{python3_sitelib}/qrexec/policy/__init__.py
%{python3_sitelib}/qrexec/policy/admin.py
%{python3_sitelib}/qrexec/policy/admin_client.py
%{python3_sitelib}/qrexec/policy/parser.py
%{python3_sitelib}/qrexec/policy/parser_compat.py
%{python3_sitelib}/qrexec/policy/utils.py

%dir %{python3_sitelib}/qrexec/tools
%dir %{python3_sitelib}/qrexec/tools/__pycache__
%{python3_sitelib}/qrexec/tools/__pycache__/*
%{python3_sitelib}/qrexec/tools/__init__.py
%{python3_sitelib}/qrexec/tools/qubes_policy.py
%{python3_sitelib}/qrexec/tools/qubes_policy_admin.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_agent.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_exec.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_daemon.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_graph.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_restore.py

%dir %{python3_sitelib}/qrexec/tests
%dir %{python3_sitelib}/qrexec/tests/__pycache__
%{python3_sitelib}/qrexec/tests/__pycache__/*
%{python3_sitelib}/qrexec/tests/__init__.py
%{python3_sitelib}/qrexec/tests/cli.py
%{python3_sitelib}/qrexec/tests/gtkhelpers.py
%{python3_sitelib}/qrexec/tests/rpcconfirmation.py
%{python3_sitelib}/qrexec/tests/policy_parser.py
%{python3_sitelib}/qrexec/tests/qrexec_policy_daemon.py
%{python3_sitelib}/qrexec/tests/policy_cache.py
%{python3_sitelib}/qrexec/tests/server.py
%{python3_sitelib}/qrexec/tests/policy_admin.py

%dir %{python3_sitelib}/qrexec/tests/socket
%dir %{python3_sitelib}/qrexec/tests/socket/__pycache__
%{python3_sitelib}/qrexec/tests/socket/__pycache__/*
%{python3_sitelib}/qrexec/tests/socket/__init__.py
%{python3_sitelib}/qrexec/tests/socket/agent.py
%{python3_sitelib}/qrexec/tests/socket/daemon.py
%{python3_sitelib}/qrexec/tests/socket/qrexec.py
%{python3_sitelib}/qrexec/tests/socket/util.py

%dir %{python3_sitelib}/qrexec/glade
%{python3_sitelib}/qrexec/glade/RPCConfirmationWindow.glade

%{_datadir}/man/man1/qubes-core-qrexec.1.gz

%files devel
%{_includedir}/qrexec.h
%{_includedir}/libqrexec-utils.h

%files libs
%{_libdir}/libqrexec-utils.so*

%changelog
* Sat Jan 28 2023 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-core-qrexec

* Sat Jan 28 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e8bb6c3
- version 4.2.3

* Fri Jan 27 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - cb9d358
- Make pylint happy

* Fri Jan 27 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 40f963b
- Do not call asyncio.get_event_loop() before creating one

* Thu Jan 26 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c04f719
- Wrap coroutine in a task before passing to asyncio.wait

* Mon Jan 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2160b2e
- version 4.2.2

* Mon Jan 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 78a5b5c
- debian: drop explicit dependency on libvchan-xen

* Fri Dec 30 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9bcb82b
- version 4.2.1

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - e35bd85
- Allow qrexec to connect to any socket

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 43941bf
- Allow qrexec to connect to anything

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 5f5f146
- try to fix more denials

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 2284438
- fix for systemd selinux rules

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 15b6af2
- Allow qrexec to start systemd services

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 5a064f8
- Try to fix an SELinux denial

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - a28c135
- Avoid running /bin/sh as local_login_t

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 20ff3db
- Set SELinux context in qrexec too

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 6d480c1
- Set agent SELinux context in systemd unit file

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 58f9450
- Allow qrexec to exec systemctl

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 75e4789
- Allow user_t to use qrexec if a boolean is set

* Thu Dec 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 6095687
- Add SELinux policy for qrexec

* Wed Dec 28 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - aa66e25
- ci: drop R4.1

* Wed Dec 28 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - f14c3ba
- Do not exit successfully if local process failed

* Mon Dec 19 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - a1f88e0
- Drop FD_SETSIZE check

* Mon Dec 19 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 3444b15
- Use clock_gettime() instead of gettimeofday()

* Mon Dec 19 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 296ec41
- Remove last use of select(2)

* Mon Dec 19 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - c428a4e
- Use a NULL fdset instead of an empty one

* Mon Dec 19 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 596edb1
- Move CLIENT_INVALID check to handle_message_from_client

* Mon Dec 19 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - ba86457
- Remove another use of select()

* Mon Dec 19 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 729f5a6
- simplify fd_set code

* Mon Dec 19 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 084a631
- Replace one use of select(2) with ppoll(2)

* Mon Dec 19 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 9dca7a7
- Abort on bad return from select()

* Mon Dec 19 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - ed16b82
- Add a ppoll_vchan() function

* Mon Dec 19 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 9724647
- Replace one use of select(2) with poll(2)

* Mon Dec 19 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 2b569b1
- Remove the connect_existing variable

* Sat Dec 17 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 6caecaf
- Prefix data support

* Sat Dec 17 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - b825533
- qrexec-client-vm: add --help

* Sat Dec 17 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 913a7c9
- More error checking

* Sat Dec 17 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 7ce5564
- Add some error checking

* Sat Dec 17 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 9b3c03c
- Zero-initialize some stack variables

* Tue Nov 29 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - da13102
- Relax validation of MSG_DATA_STDIN/MSG_DATA_STDOUT

* Wed Nov 23 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9cc1580
- Update fuzzer wrapper

* Mon Nov 21 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 6daa16d
- Prevent log injection into qrexec-agent

* Sun Oct 16 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - d1098cc
- Only spawn services via exec

* Tue Oct 11 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 63dfb73
- version 4.2.0

* Mon Sep 05 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - feea49e
- ci: install extra packages necessary for unit tests

* Sun Aug 07 2022 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 961bf3c
- Add Qubes Builder v2 integration

* Fri Jul 29 2022 Marta Marczykowska-Górecka <marta.maria.gorecka@gmail.com> - a4e331c
- Fix empty file list in PolicyClient.get_files

* Mon Jul 11 2022 Marta Marczykowska-Górecka <marta.maria.gorecka@gmail.com> - 416abe8
- Apply @marmarek's code review

* Fri Jul 08 2022 Marta Marczykowska-Górecka <marta.maria.gorecka@gmail.com> - 375b542
- Fix incorrect ownership of policy dirs

* Wed Jul 06 2022 locriacyber <74560659+locriacyber@users.noreply.github.com> - 62a258e
- Update archlinux/PKGBUILD

* Wed Jul 06 2022 Marta Marczykowska-Górecka <marta.maria.gorecka@gmail.com> - aecb3fc
- add more tests to placate codecov

